//---------------------------------------------------------------------------
//
// Author : RichTop @ Delphi K.Top
//
// This is a freeware that can be used and modified for any form and purpose.
// It is developed in Borland C++ Builder 6.0 professional by RichTop.
//

#include <vcl.h>
#pragma hdrstop

#include "BCBHexViewer0.h"
#include <string.h>
#include <time.h>
#include <stdio.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)

#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
AnsiString msg;
char digits[]="0123456789ABCDEF" ;  // dkA[t10i16i

void streamFillHexView(TMemoryStream * stream)
{
  char result[78]; // ۮeAnsiStringrs覡AƱq}lresult[1]sC
  unsigned char *msg, ch;
  int len, pIdx, idx;

  if ( stream==NULL ) return;

  stream->Position = 0;
  msg = new unsigned char[16];

  //TDateTime time = Now();

  TMemoryStream * pms = new TMemoryStream();

  pms->Size = ((stream->Size+15)/16*77);

  pIdx=0;
  len = 0;

  stream->Position = 0; // It must be set properly.
  for (int k=0; k<stream->Size; k+=16)
     { sprintf((result+1),"%08X:%67s\n", k, " ");
       idx = 10;

       if ( k+15 < stream->Size ) len = 16;
       else len = (stream->Size - k + 1);

       stream->Read(msg, len);
       for (int p=0; p<len; p++)
          { ch = (unsigned char) msg[p];
            if ( p==8 )
              { idx += 2;  // insert 2 blanks
                result[idx++] = digits[ch >> 4  ];
                result[idx++] = digits[ch & 0x0F];
              }
            else
              { idx++;  // insert 1 blank
                result[idx++] = digits[ch >> 4  ];
                result[idx++] = digits[ch & 0x0F];
              }
          }
       idx = 76-15;  // go to the beginning of char showing
       for (int p=0; p<len; p++)
          { ch = (unsigned char) msg[p];
            if ( ch>127 || ch<32 )
              { result[idx++] = '.';
              }
            else
              { result[idx++] = ch;
              }
          }
       pms->Position = pIdx;
       pIdx += 77;
       pms->Write((result+1), 77);
     }
  /*
  time = Now() - time;
  double dSec = double(time)*24*60*60;
  ShowMessage(FloatToStr(dSec)+" second(s)");

  time = Now();
  */
  pms->Position = 0; // It is very importent.
  Form1->RichEdit1->Lines->LoadFromStream(pms);  // Good!

  //Form1->RichEdit1->Lines->Assign(lst);  // No Good!
  //Form1->Memo1->Lines->Assign(lst);      // No Good!
  /*
  time = Now() - time;
  dSec = double(time)*24*60*60;
  ShowMessage(FloatToStr(dSec)+" second(s)- The End.");
  */
  delete pms;
  delete [] msg;
}
void __fastcall TForm1::showMsg()
{ msg.printf("row: %d,  col: %d,  total row(s): %d",
              1+RichEdit1->CaretPos.y, 1+RichEdit1->CaretPos.x, RichEdit1->Lines->Count);
  StatusBar1->SimpleText = msg;
}
void __fastcall TForm1::RichEdit1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  showMsg();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RichEdit1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  showMsg();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::HexViewr1Click(TObject *Sender)
{
  if ( OpenDialog1->Execute() )
    { TMemoryStream* pms = new TMemoryStream();
      try {
            pms->LoadFromFile(OpenDialog1->FileName);
            //pms->Position = 0;                     // reset to the beginning of the stream.
            //RichEdit1->Lines->LoadFromStream(pms); // load stream contents into RichEdit control.

            streamFillHexView(pms);
            FileName1->Caption = OpenDialog1->FileName;
            showMsg();
            RichEdit1->SetFocus();
          }
      __finally
        {
           delete pms;
        }
    }        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LoadasText1Click(TObject *Sender)
{
  if ( OpenDialog1->Execute() )
    { RichEdit1->Lines->LoadFromFile(OpenDialog1->FileName);
      FileName1->Caption = OpenDialog1->FileName;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetFont1Click(TObject *Sender)
{
  if ( FontDialog1->Execute() )
    { RichEdit1->Font = FontDialog1->Font;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetViewerColor1Click(TObject *Sender)
{
  if ( ColorDialog1->Execute() )
    { RichEdit1->Color = ColorDialog1->Color; 
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::About1Click(TObject *Sender)
{
  ShowMessage("Enjoy the program from RichTop.");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormActivate(TObject *Sender)
{
  RichEdit1->SetFocus();
  showMsg();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
  showMsg();
}
//---------------------------------------------------------------------------

